divert(-1)
dnl This is the sendmail macro config file. If you make changes to this file,
dnl you need the sendmail-cf rpm installed and then have to generate a
dnl new /etc/sendmail.cf by running the following command:
dnl
dnl        m4 /home/joe/tmp/smetc/mail/sendmail.mc > /etc/sendmail.cf
dnl
dnl include(`/usr/lib/sendmail-cf/m4/cf.m4')
define(`_USE_ETC_MAIL_')dnl
include(`/home/joe/download/sendmail/sendmail-8.13.8-mr16/cf/m4/cf.m4')dnl
VERSIONID(`linux setup for joe maimon')dnl
OSTYPE(`linux')
dnl
define(`_FFR_MAIL_MACRO')dnl
define(`_FFR_MILTER_RWSETS')dnl
define(`_FFR_MILTER_RWSETS_RESPONSE')dnl
define(`_FFR_MILTER_REWRITE')dnl
define(`_FFR_MILTER_EAGAIN')dnl
define(`_FFR_SKIP_RSCHECKS')dnl
define(`_FFR_BADRCPT_SHUTDOWN')dnl
define(`_FFR_MILTER_SM_CLASS')dnl
define(`_FFR_MILTER_SM_MAP')dnl
define(`_FFR_MILTER_SM_TESTMODE')dnl
dnl define(`_FFR_MULTILINE_ERRORS')dnl
dnl
dnl
dnl	System DEFINES, file locations	
dnl
dnl define(`confDEF_USER_ID',``smmta:smmsp'')dnl
define(`confTRUSTED_USER',`joe')dnl
undefine(`UUCP_RELAY')dnl
undefine(`BITNET_RELAY')dnl
dnl define(`confPID_FILE',`/var/run/sendmail/mta/sendmail.pid')dnl
dnl define(`confCONTROL_SOCKET_NAME',`/var/run/sendmail/mta/smcontrol')dnl
dnl
dnl 
dnl  Configuration DAEMON Behavior Defines
dnl
dnl
define(`confDOMAIN_NAME',`smtp2.ttec.com')dnl
define(`confTRY_NULL_MX_LIST',true)dnl
define(`confDONT_PROBE_INTERFACES',true)dnl
define(`confPRIVACY_FLAGS', `authwarnings,novrfy,noexpn,restrictqrun')dnl
define(`confDONT_BLAME_SENDMAIL',`GroupWritableIncludeFile,IncludeFileInGroupWritableDirPath')dnl
define(`confLOG_LEVEL',`10')dnl

FEATURE(`no_default_msa')dnl
DAEMON_OPTIONS(`Port=2526, Name=MTA')dnl
dnl DAEMON_OPTIONS(`port=smtp,Addr=::1, Name=MTA-v6, Family=inet6')
DAEMON_OPTIONS(`Port=2527, Name=MSA, M=Ea')dnl
DAEMON_OPTIONS(`Port=2528, Name=MTAS, M=Eas')dnl
dnl
dnl
dnl	Other sendmail/procmail/alias/status defines
dnl
dnl
define(`QUEUE_DIR',`/home/joe/tmp/spool/mqueue')dnl
define(`confUSERDB_SPEC', `/home/joe/tmp/smetc/mail/userdb.db')dnl
define(`PROCMAIL_MAILER_PATH',`/usr/bin/procmail')dnl
define(`confTO_HOSTSTATUS', `5')dnl
define(`confHOST_STATUS_DIRECTORY',`/var/lib/sendmail/host_status')dnl
define(`ALIAS_FILE', `/home/joe/tmp/smetc/mail/aliases')dnl
define(`STATUS_FILE', `/home/joe/tmp/smetc/mail/statistics')dnl
define(`UUCP_MAILER_MAX', `2000000')dnl
define(`confFORWARD_PATH',`')dnl
dnl
dnl
dnl	SMTP AUTH configuratuion
dnl	
dnl
define(`confAUTH_OPTIONS', `A')dnl
dnl TRUST_AUTH_MECH(`DIGEST-MD5 CRAM-MD5 PLAIN LOGIN')dnl
TRUST_AUTH_MECH(`DIGEST-MD5 LOGIN PLAIN')dnl
dnl define(`confAUTH_MECHANISMS', `DIGEST-MD5 CRAM-MD5 LOGIN PLAIN')dnl
define(`confAUTH_MECHANISMS', `DIGEST-MD5 PLAIN LOGIN')dnl
dnl
dnl
dnl	Timeouts
dnl
dnl
define(`confTO_CONNECT', `1m')dnl
define(`confTO_QUEUEWARN', `4h')dnl
define(`confTO_QUEUERETURN', `5d')dnl
define(`confQUEUE_LA', `12')dnl
define(`confREFUSE_LA', `18')dnl
define(`confTO_QUEUERETURN_DSN', `2')dnl
define(`confTO_QUEUEWARN_DSN', `12h')dnl
dnl
dnl
dnl	SMTP STARTTLS Configuration
dnl
dnl
define(`confCACERT_PATH',`/etc/ssl/certs')dnl
define(`confCACERT',`/etc/ssl/certs/ca-bundle.crt')dnl
define(`confSERVER_CERT',`/home/joe/tmp/smetc/mail/certs/sm-server.pub.pem')dnl
define(`confSERVER_KEY',`/home/joe/tmp/smetc/mail/certs/sm-server.pri.pem')dnl
define(`confCLIENT_CERT',`/home/joe/tmp/smetc/mail/certs/sm-client.pub.pem')dnl
define(`confCLIENT_KEY',`/home/joe/tmp/smetc/mail/certs/sm-client.pri.pem')dnl
dnl
dnl
dnl	MILTERS
dnl
dnl
define(`MILTER', 0)dnl
define(`confMILTER_LOG_LEVEL', `7')dnl
define(`confMILTER_MACROS_ENVRCPT',`{rcpt_mailer},{rcpt_host},{rcpt_addr},h,{Host}')dnl
define(`confMILTER_EAGAIN')dnl
define(`confMILTER_REWRITE',`ndp')dnl
define(`confMILTER_SM_CLASS',`ndplakx')dnl
define(`confMILTER_SM_MAP',`ndp')dnl
define(`confMILTER_REWRITE_RULESET', `rewrite_ruleset/rewrite_ruleset_strings')dnl
define(`confMILTER_RWSETS')dnl
define(`confMILTER_RWSETS_RESPONSE')dnl
define(`confMILTER_SM_TESTMODE',`ndpb')dnl
dnl INPUT_MAIL_FILTER(`rcpt-milter', `S=local:/var/run/sendmail/rcpt-milter.sock, F=, T=C:20s;S:30s;R:30s;E:1m')dnl
dnl INPUT_MAIL_FILTER(`null-milter',`S=local:/var/run/sendmail/null-milter.sock,F=,T=S:4m;R:4m')dnl
dnl INPUT_MAIL_FILTER(`milter-regexp', `S=local:/var/run/sendmail/milter-regexp.sock, F=, T=S:4m;R:4m')dnl
dnl INPUT_MAIL_FILTER(`milter-ahead-test', `S=local:/home/joe/tmp/milter-ahead.sock, F=, T=C:20s;S:30s;R:30s;E:1m')dnl
dnl INPUT_MAIL_FILTER(`clamav-milter', `S=local:/var/run/clamav/clamav-milter.ctl, F=, T=C:20s;S:30s;R:30s;E:1m')dnl
dnl INPUT_MAIL_FILTER(`milter-amavis', `S=local:/var/lib/amavis/amavisd-new-milter.sock, F=, T=S:1m;R:4m;E:4m')dnl
dnl INPUT_MAIL_FILTER(`spamassassin', `S=local:/var/run/sendmail/spamass.sock, F=, T=C:15m;S:4m;R:4m;E:10m')
dnl INPUT_MAIL_FILTER(`verbose-milter', `S=local:/home/joe/tmp/verbose-milter.sock, F=, T=C:30s;S:1m;R:1m;E:1m')
INPUT_MAIL_FILTER(`verbose-milter', `S=local:/home/joe/tmp/verbose-milter.sock, R=+-r:R:Response;m:Response, E=ndplabkx, F=OPCWG, T=C:30s;S:1m;R:1m;E:1m')dnl
INPUT_MAIL_FILTER(`verbose-milter2', `S=local:/home/joe/tmp/verbose-milter.2.sock, R=+-r:R:Response;m:Response, E=ndplabkx, F=OPCWG, T=C:30s;S:1m;R:1m;E:1m')dnl
INPUT_MAIL_FILTER(`verbose-milter3', `S=local:/home/joe/tmp/verbose-milter.3.sock, R=+-r:R:Response;m:Response, E=ndplabkx, F=OPCWG, T=C:30s;S:1m;R:1m;E:1m')dnl
INPUT_MAIL_FILTER(`verbose-milter4', `S=local:/home/joe/tmp/verbose-milter.4.sock, R=+-r:R:Response;m:Response, E=ndplabkx, F=OPCWG, T=C:30s;S:1m;R:1m;E:1m')dnl
INPUT_MAIL_FILTER(`verbose-milter5', `S=local:/home/joe/tmp/verbose-milter.5.sock, R=+-r:R:Response;m:Response, E=ndplabkx, F=OPCWG, T=C:30s;S:1m;R:1m;E:1m')dnl
INPUT_MAIL_FILTER(`verbose-milter6', `S=local:/home/joe/tmp/verbose-milter.6.sock, R=+-r:R:Response;m:Response, E=ndplabkx, F=OPCWG, T=C:30s;S:1m;R:1m;E:1m')dnl
INPUT_MAIL_FILTER(`verbose-milter7', `S=local:/home/joe/tmp/verbose-milter.7.sock, R=+-r:R:Response;m:Response, E=ndplabkx, F=OPCWG, T=C:30s;S:1m;R:1m;E:1m')dnl
dnl INPUT_MAIL_FILTER(`clamav-milter-test', `S=local:/home/joe/tmp/clamav-milter.sock, F=WG, T=C:30s;S:1m;R:1m;E:1m,R=M:MailRuleSet;R:S:RcptRuleSet;R:N:spamFriend')
dnl define(`confINPUT_MAIL_FILTERS', `clamav-milter,milter-amavis,spamassassin')dnl
dnl define(`confINPUT_MAIL_FILTERS', `verbose-milter')dnl
dnl
dnl
dnl	Accept all mail that we are best mx for  and forward as is to mailserver
dnl
dnl
dnl define(`_PRESERVE_HOST_ON_LOCAL_')dnl			MY DIRTY HACK!
dnl define(`LUSER_RELAY',`esmtp:pop3.ttec.com')dnl
dnl FEATURE(`preserve_luser_host')dnl
dnl define(`MAIL_HUB',`esmtp:pop3.ttec.com')dnl 		Send it all to mailserver!
dnl FEATURE(`bestmx_is_local')dnl				Accept it all!
dnl
dnl
dnl	mailertable/virtusetable USER processing
dnl
dnl
FEATURE(`always_add_domain',`ttec.com')dnl
FEATURE(`smrsh')dnl
FEATURE(`mailertable',`hash -o /home/joe/tmp/smetc/mail/mailertable.db')dnl
define(`_MY_DIRTY_VIRTUSER_LOCALPART_HACK_')dnl
VIRTUSER_DOMAIN_FILE(`/home/joe/tmp/smetc/mail/virtuserdomains')dnl
FEATURE(`virtusertable',`hash -o /home/joe/tmp/smetc/mail/virtusertable.db')dnl
FEATURE(redirect)dnl
FEATURE(use_cw_file)dnl
FEATURE(use_ct_file)dnl
FEATURE(local_procmail,`',`procmail -t -Y -a $h -d $u')dnl
dnl
dnl
dnl	Anti SPAM features, relay and access control behavior
dnl
dnl
FEATURE(`access_db',`hash -T<TMPF> /home/joe/tmp/smetc/mail/access.db')dnl
FEATURE(`blacklist_recipients')dnl
FEATURE(`delay_checks',`friend')dnl
FEATURE(`compat_check')dnl
EXPOSED_USER(`root')dnl
dnl FEATURE(`accept_unresolvable_domains')dnl
FEATURE(`relay_based_on_MX')dnl
dnl FEATURE(`relay_mail_from',`domain')dnl
dnl
dnl
dnl	Blacklists and Other ANTI SPAM
dnl
dnl
define(`DNSBL_MAP', `dns -R A -r2')dnl
dnl define(`_WHITELIST_RHSBL_HACK_')dnl
FEATURE(`dnsbl',`sbl-xbl.spamhaus.org',`"Spam BlockListed - see: http://www.spamhaus.org/query/bl?IP="$&{client_addr}')dnl
FEATURE(`dnsbl',`list.dsbl.org',`"Spam BlockListed - see: http://dsbl.org/listing?"$&{client_addr}')dnl 
FEATURE(`dnsbl',`dnsbl.njabl.org',`"Spam BlockListed - see: http://njabl.org/cgi-bin/lookup.cgi?query="$&{client_addr}')dnl 
FEATURE(`dnsbl',`bl.spamcop.net',`"Spam BlockListed - see: http://spamcop.net/bl.shtml?"$&{client_addr}')dnl 
dnl FEATURE(`dnsbl',`cbl.abuseat.org',dnl
dnl `"Spam BlockListed - see: http://cbl.abuseat.org/lookup.cgi?ip="$&{client_addr}')dnl 
FEATURE(`dnsbl',`spam.dnsrbl.net',dnl
`"Spam BlockListed - see: http://www.dnsrbl.com/lookupserver.jsp and put this address in : "$&{client_addr}')dnl 
FEATURE(`dnsbl',`dun.dnsrbl.net',dnl
`"Spam BlockListed - see: http://www.dnsrbl.com/lookupserver.jsp and put this address in : "$&{client_addr}')dnl 
FEATURE(`dnsbl',`dnsbl.sorbs.net',dnl
`"Spam BlockListed - see: http://www.dnsbl.sorbs.net/cgi-bin/lookup?IP="$&{client_addr}')dnl
FEATURE(`dnsbl',`relays.ordb.org',`"Spam BlockListed - see: http://ordb.org/lookup/?host="$&{client_addr}')dnl 
FEATURE(`dnsbl',`l1.spews.dnsbl.sorbs.net',dnl
`"Spam BlockListed - see: http://www.spews.org/ask.cgi?x="$&{client_addr}')dnl 
FEATURE(`dnsbl',`dsn.rfc-ignorant.org',dnl
`"Mail refused. You must accept return email. 'dnl
`See: http://www.rfc-ignorant.org/tools/lookup.php?domain="$&{client_addr}')dnl  

dnl FEATURE(`dnsbl',`psbl.surriel.com',dnl
dnl `"Spam BlockListed - to remove see: http://psbl.surriel.com/cgi-bin/listing.cgi?ip="$&{client_addr}')dnl 
dnl HACK(`dnsblaccess',`blackholes.five-ten-sg.com',dnl
dnl `"Spam BlockListed - see: http://www.five-ten-sg.com/blackhole.php?ip="$&{client_addr}',dnl
dnl `ttec.bl.510sg')dnl
dnl
dnl
dnl   Daemon Rate Control
define(`confBAD_RCPT_THROTTLE',`5')dnl
define(`confCONNECTION_RATE_THROTTLE',`20')dnl
define(`confMAX_DAEMON_CHILDREN',`50')dnl
FEATURE(`ratecontrol',`nodelay')dnl
FEATURE(`conncontrol',`nodelay')dnl
dnl
dnl
dnl
dnl     QUeue Processing
define(`confMAX_RUNNERS_PER_QUEUE',`5')dnl
dnl
dnl
dnl	Mailers
dnl
dnl
MAILER(smtp)dnl
MAILER(procmail)dnl
dnl
dnl
dnl
dnl
LOCAL_CONFIG
# dynamic relay authorization control map
C{RADACCT} alerondial.net
C{SNMPMAC} nobody.com
dnl verizon.net optonline.net ba-dsg.net aol.com
Kdrac btree -o /home/joe/tmp/smetc/mail/dracd
Kradlookup program /usr/local/libexec/radacctresolv -e 
Ksnmpmaclookup program /usr/local/libexec/snmpMAClookup -e
Kstorage macro
dnl Kip4address dns -RA
dnl ip6address dns -RAAAA

dnl
LOCAL_RULESETS
SLocal_trust_auth
R$*	$: $&{auth_authen}
Rsmmsp	$# OK
Rroot	$# OK
		
SRecurse_domain
R$-.$+				$@ $2

SLocal_check_rcpt
R$*				$: $>"set_postmaster_address" $&{rcpt_addr}
R$*				$: $(storage {CHK_RCPT_PARM} $@ $1 $) $&{client_name}
R$*				$: $>"access_from_check" $&f
R$* OK				$@ OK
R$*				$: $>"access_connect_check" $&{client_name} $| $&{client_addr}
R$* OK				$@ OK
R$*				$: $>"drac_check_relay"
R$*				$: $&{client_name}
R$*$={RADACCT}			$: $>"radacct_check_relay" $&{client_addr}
R$*$={SNMPMAC}			$: $>"snmpmac_check_relay" $&{client_addr}
R$*				$: $&{CHK_RCPT_PARM}			# Keep for virtusertable reference

Sdrac_check_relay
# allow recent POP/IMAP mail clients to relay
R$*				$: $&{client_addr}
R$+				$: $(drac $1 $: ? $)
R?				$@ ?
R$+				$@ $#OK

Sradacct_check_relay
# Lookup client address in radius accounting data
R$*				$: $&{client_addr}
R$+				$: $(radlookup $1 $: ? $)
R < OK >			$@ $#OK
R*				$@ ?

Ssnmpmac_check_relay
R$*				$: $&{client_addr}
R$+				$: $(snmpmaclookup $1 $: ? $)
R < OK >			$@ $#OK
R*				$@ ?

Sset_postmaster_address
R$*				$: $(storage {POSTMASTER_ADDRESS} $@ $) $1
R$+ @ $*			$2
R$=w				$@ $(storage {POSTMASTER_ADDRESS} $@ postmaster @ $1 $) $1
R$*$={CHL_DOMAINS}		$@ $(storage {POSTMASTER_ADDRESS} $@ postmaster @ chl . com $)
R$*$={TTEC_DOMAINS}		$@ $(storage {POSTMASTER_ADDRESS} $@ postmaster @ ttec . com $)

Saccess_connect_check
R$+ $| $+		$: $>D < $1 > <?> <+ Connect> < $2 >
R   $| $+ 		$: $>A < $1 > <?> <+ Connect> <>	empty client_name
R<?> <$+> 		$: $>A < $1 > <?> <+ Connect> <>	no: another lookup
R<?> <$*>		$@ ?				found nothing
R<$={Accept}> <$*>	$@ $1				return value of lookup
R<REJECT> <$*>		$#error $@ 5.7.1 $: "550 Access denied"
R<DISCARD> <$*>		$#discard $: discard
R<ERROR:$-.$-.$-:$+> <$*>	$#error $@ $1.$2.$3 $: $4
R<ERROR:$+> <$*>		$#error $: $1
R<$* <TMPF>> <$*>		$#error $@ 4.3.0 $: "451 Temporary system failure. Please try again later."
R<$+> $*		$#error $: $1

Saccess_from_check
# check sender address: user@address, user@, address
R$*			$: <?> $>CanonAddr $1		canonify sender address and mark it
R<$+> $+ < @ $* . >	$: <$1> $2 < @ $3 >
R<$+> $+ < @ $* >	$: @<$1> <$2 < @ $3 >> $| <F:$2@$3> <U:$2@> <D:$3>
R<$+> $+		$: @<$1> <$2> $| <U:$2@>
R@ <$+> <$*> $| <$+>	$: <@> <$1> <$2> $| $>SearchList <+ From> $| <$3> <>
R<@> <$+> <$*> $| <$*>	$: <$3> <$1> <$2>		reverse result
# retransform for further use
R<?> <$*> <$*>		$@ ?	no match
R<$+> <$+> <$*>		$: <$1> $3	relevant result, keep it
R<$={Accept}> $*	$# $1		accept from access map
R<DISCARD> $*		$#discard $: discard
R<REJECT> $*		$#error $@ 5.7.1 $: "550 Access denied"
R<ERROR:$-.$-.$-:$+> $*	$#error $@ $1.$2.$3 $: $4
R<ERROR:$+> $*		$#error $: $1
R<<TMPF>> $*		$#error $@ 4.3.0 $: "451 Temporary system failure. Please try again later."
R<$+> $*		$#error $: $1




SVerisign_Screwed_Us
R $*					$: $>canonify $1
R $* < @ $+ . > $*			$1 < @ $2 > $3
R $* < @ $+ > $*			$: $1 < @ $(dnsa $2 $) > $3
R $* < @ $={evil_ip} <OKR> > $*		$#error $@ 5.1.8 $: "553 Domain of address " $&f " does not exist"

SMX_is_bogus
R$*			$: $1 <?> $| <?> $>CanonAddr $&f
R$* <?> $| <?> $*<@$+.>	$: $1 



SConnectRuleSet
R$*			$: $&{client_name}
R$=w			$#error

SMailRuleSet
Rpostmaster @ $=w	$#error

SRcptRuleSet
R<blechy@ttec.com>	$#error
Rpostmaster @ $=w	$#error
Rpostmaster@$*		$#error

SspamFriend
dnl R$*				$: $1 $| $&{rcpt_mailer}
dnl R$* $| error			$#discard
dnl R$* $| $*			$: $1
R<schmucky>			$#ok
R$*				$: <> $>canonify $1
R<> $* < @ $+ . > $*		<> $1 < @ $2 > $3
R<> $+ < @ $* > $*		$: <L> $1 < @ $2 > $3  $| <F: $1@$2 > <D: $2 > <U: $1@>
R<> $*				$: <L> $1 $| <U: $1@>
R<> $*				$@ $1
R<L> $* $| $*			$: <L> $1 $| $>SearchList <! Spam> $| $2 <>
R<L> $+ < @ $+ > $| <?>		$@ $1@$2
R<L> $* $| <FRIEND>		$#discard
R<L> $+ < @ $+ > $| $*		$@ $1@$2
R<L> $* $|			$@ $1

SisSpamtrap
R$*				$: $(storage {isSpamtrap_args} $@ $1 $) $1
R$*				$: $1 $| $&{rcpt_mailer}
R$* $| error			$#discard
R$* $| $*			$:<!>$>canonify $1
R<!> $+ < @ $* . > 	$: < $(virtuser $1 @ $2 $@ $1 $@ $2  $: @ $) > $1 < @ $2 . >
R<@> $+ + $+ < @ $* . >
			$: < $(virtuser $1 + + @ $3 $@ $1 $@ $2 $@ +$2 $: @ $) > $1 + $2 < @ $3 . >
R<@> $+ + $* < @ $* . >
			$: < $(virtuser $1 + * @ $3 $@ $1 $@ $2 $@ +$2 $: @ $) > $1 + $2 < @ $3 . >
R<@> $+ + $* < @ $* . >
			$: < $(virtuser $1 @ $3 $@ $1 $@ $2 $@ +$2 $: @ $) > $1 + $2 < @ $3 . >
R<@> $+ + $+ < @ $+ . >	$: < $(virtuser + + @ $3 $@ $1 $@ $2 $@ +$2 $: @ $) > $1 + $2 < @ $3 . >
R<@> $+ + $* < @ $+ . >	$: < $(virtuser + * @ $3 $@ $1 $@ $2 $@ +$2 $: @ $) > $1 + $2 < @ $3 . >
R<@> $+ + $* < @ $+ . >	$: < $(virtuser @ $3 $@ $1 $@ $2 $@ +$2 $: ! $) > $1 + $2 < @ $3 . >
R<@> $+ < @ $+ . >	$: < $(virtuser @ $2 $@ $1 $: @ $) > $1 < @ $2 . >

R<@> $+ < @ $* . > 	$: < $(virtuser $1 @ $@ $1 $@ $2 $: @ $) > $1 < @ $2 . >
R<@> $+ < @ $* . > 	$: < $(virtuser $1 @ $@ $1 $@ $2 $: @ $) > $1 < @ $2 . >
R<spamtrap@psbl.ttec.net> $*	$#discard
dnl R$*			$: $&{isSpamtrap_args}
dnl R$*			$: $1 $(storage {isSpamtrap_args} $@ $)
R$*			$@ $1

Srewrite_ruleset
R$* bookus $* $| $*	$@ $1 $| gookus $| lookus $| $2	
R$* bookus $* $| $*	$@ gookus
R$*			$@

Sgookus
R$*			$#OK $: "You stink"

Slookus
R$*			$#ok    $: "We love you"

Srewrite_ruleset_strings
R$* $| $*		$: $1 $| $2 $| $&{milter_rcvd_options} $|
R$* $| $* $| $*n$* $|	$: $1 $| $2 $| GotN $|
R$*			$@

SResponse
R$* $| $*		$#error
R$*			$: $&{milter_cmd}
Rr			$@t
R$*			$#error
